<?php
/*
Plugin Name: WordCamp Poznań 2011
Plugin URI: http://wordpress.org/extend/plugins/wordcamp-poznan-2011/
Description: Wtyczka na konferencję WordCamp Poznań 2011
Author: Vokiel
Version: 0.1.7
Author URI: http://blog.vokiel.com/plugins/wordcamp-poznan-2011/
Licence: GPL2
*/

if ( !class_exists("WordCampPoznan2011") ){ // ok, droga wolna
	
	define('WORDCAMP_PLUGIN_VERSION','0.1.7');
	define('WORDCAMP_PLUGIN_LONGNAME','wordcamp');
	define('WORDCAMP_PLUGIN_SHORTNAME','wcpoz');
	define('WORDCAMP_PLUGIN_OPTIONS','WordCampPoznan2011PluginOptions');
	define('WORDCAMP_PLUGIN_BASEDIR',dirname(plugin_basename(__FILE__)));
	define('WORDCAMP_PLUGIN_BASEURL',plugins_url('',__FILE__));
	
	class WordCampPoznan2011 {
		
		protected static $default_options = array(
			'twitter_hashtag' => WORDCAMP_PLUGIN_SHORTNAME,
			'last_version' => WORDCAMP_PLUGIN_VERSION
		);
		
		public static function init_admin_menu(){
			add_menu_page( 'WordCamp Poznań 2011', 'WordCamp', 'manage_options', WORDCAMP_PLUGIN_LONGNAME, array('WordCampPoznan2011', 'menu_page'),WORDCAMP_PLUGIN_BASEURL.'/img/wordpress-logo-16-blue.png');
			
			$sub = add_submenu_page( WORDCAMP_PLUGIN_LONGNAME, 'WordCamp - Informacje', 'Informacje', 'manage_options', 'wordcamp', array('WordCampPoznan2011', 'menu_page') );
			add_action('load-'.$sub, array('WordCampPoznan2011','menu_head'));
			$sub = add_submenu_page( WORDCAMP_PLUGIN_LONGNAME, 'WordCamp - Ustawienia', 'Ustawienia', 'manage_options', 'wordcamsettings', array('WordCampPoznan2011', 'menu_page') );			
			add_action('load-'.$sub, array('WordCampPoznan2011','menu_head'));
			
		}
		public static function menu_page(){
			if ( !current_user_can('manage_options') ){ 
				wp_die( 'Brak uprawnień' ); 
			}
			$menu_pages = array('wordcamp','wordcamsettings');
			if ( !empty($_REQUEST['page']) and in_array($_REQUEST['page'],$menu_pages) ) {
				$page = $_REQUEST['page'];
				if ( is_file(dirname(__FILE__).'/src/menu_'.$page.'.php')){ 
					require_once(dirname(__FILE__).'/src/menu_'.$page.'.php');
				}
			}
		}
		public static function menu_head(){
			wp_enqueue_style(WORDCAMP_PLUGIN_LONGNAME,WORDCAMP_PLUGIN_BASEURL.'/css/settings.css','',WORDCAMP_PLUGIN_VERSION,'screen');
		}
		public static function plugin_activate(){
			$options = get_option(WORDCAMP_PLUGIN_OPTIONS);
			if ( empty($options['last_version']) || $options['last_version'] == WORDCAMP_PLUGIN_VERSION){
				$options = self::$default_options;
				update_option(WORDCAMP_PLUGIN_OPTIONS,$options);
			}
		}
		public static function plugin_deactivate(){
			$options = get_option(WORDCAMP_PLUGIN_OPTIONS);
			if ( $options['last_activate'] ){
				$options['last_activate'] = '';
			}
			update_option(WORDCAMP_PLUGIN_OPTIONS,$options);
		}
	}
	
	register_activation_hook( __FILE__, array('WordCampPoznan2011','plugin_activate') );
	register_deactivation_hook(__FILE__, array('WordCampPoznan2011','plugin_deactivate'));
	add_action('admin_menu', array('WordCampPoznan2011','init_admin_menu'));
	
}