<?php
/*
Plugin Name: WordCamp Poznań 2011
Plugin URI: http://wordpress.org/extend/plugins/wordcamp-poznan-2011/
Description: Wtyczka na konferencję WordCamp Poznań 2011
Author: Vokiel
Version: 0.1.8
Author URI: http://blog.vokiel.com/plugins/wordcamp-poznan-2011/
Licence: GPL2
*/

if ( !class_exists("WordCampPoznan2011") ){ // ok, droga wolna
	
	define('WORDCAMP_PLUGIN_VERSION','0.1.8');
	define('WORDCAMP_PLUGIN_LONGNAME','wordcamp');
	define('WORDCAMP_PLUGIN_SHORTNAME','wcpoz');
	define('WORDCAMP_PLUGIN_OPTIONS','WordCampPoznan2011PluginOptions');
	define('WORDCAMP_PLUGIN_BASEDIR',dirname(plugin_basename(__FILE__)));
	define('WORDCAMP_PLUGIN_BASEURL',plugins_url('',__FILE__));
	
	class WordCampPoznan2011 {
		
		protected static $default_options = array(
			'twitter_hashtag' => WORDCAMP_PLUGIN_SHORTNAME,
			'last_version' => WORDCAMP_PLUGIN_VERSION
		);
		
		public static function init_admin_menu(){
			add_menu_page( 'WordCamp Poznań 2011', 'WordCamp', 'manage_options', WORDCAMP_PLUGIN_LONGNAME, array('WordCampPoznan2011', 'menu_page'),WORDCAMP_PLUGIN_BASEURL.'/img/wordpress-logo-16-blue.png');
			
			$sub = add_submenu_page( WORDCAMP_PLUGIN_LONGNAME, 'WordCamp - Informacje', 'Informacje', 'manage_options', 'wordcamp', array('WordCampPoznan2011', 'menu_page') );
			add_action('load-'.$sub, array('WordCampPoznan2011','menu_head'));
			$sub = add_submenu_page( WORDCAMP_PLUGIN_LONGNAME, 'WordCamp - Ustawienia', 'Ustawienia', 'manage_options', 'wordcamsettings', array('WordCampPoznan2011', 'menu_page') );			
			add_action('load-'.$sub, array('WordCampPoznan2011','menu_head'));
			
			add_filter('plugin_action_links_'.WORDCAMP_PLUGIN_BASEDIR.'/wordcamppoznan2011.php', array('WordCampPoznan2011','options_link'));
		}
		public static function menu_page(){
			if ( !current_user_can('manage_options') ){ 
				wp_die( 'Brak uprawnień' ); 
			}
			$menu_pages = array('wordcamp','wordcamsettings');
			if ( !empty($_REQUEST['page']) and in_array($_REQUEST['page'],$menu_pages) ) {
				$page = $_REQUEST['page'];
				if ( is_file(dirname(__FILE__).'/src/menu_'.$page.'.php')){ 
					require_once(dirname(__FILE__).'/src/menu_'.$page.'.php');
				}
			}
		}
		public static function menu_head(){
			wp_register_style(WORDCAMP_PLUGIN_LONGNAME, WORDCAMP_PLUGIN_BASEURL.'/css/settings.css','',WORDCAMP_PLUGIN_VERSION,'screen');
			wp_enqueue_style(WORDCAMP_PLUGIN_LONGNAME);
		}
		public static function plugin_activate(){
			$options = get_option(WORDCAMP_PLUGIN_OPTIONS);
			if ( empty($options['last_version']) || $options['last_version'] == WORDCAMP_PLUGIN_VERSION){
				$options = self::$default_options;
				update_option(WORDCAMP_PLUGIN_OPTIONS,$options);
			}
		}
		public static function plugin_deactivate(){
			$options = get_option(WORDCAMP_PLUGIN_OPTIONS);
			if ( $options['last_activate'] ){
				$options['last_activate'] = '';
			}
			update_option(WORDCAMP_PLUGIN_OPTIONS,$options);
		}
		public static function options_link($links){
			if ( !current_user_can('manage_options') ){ 
				return $links;
			}
			$settings_link = '<a href="'.admin_url('admin.php').'?page=wordcamsettings" title="Ustawienia" class="edit">Ustawienia</a>';
			array_unshift( $links, $settings_link );
			return $links;
		}
		
		public static function add_dashboard_widget(){
			if ( !current_user_can('manage_options') ){ 
				return $links; 
			}
			$options = get_option(WORDCAMP_PLUGIN_OPTIONS);
			echo '<table style="width: 50%; clear: both;"><tr><td style="font-weight: bold;">Aktaulny HashTag:</td><td>'.$options['twitter_hashtag'].'</td></tr></table>';
			echo '<p class="submit"><a href="'.admin_url('admin.php').'?page=wordcamsettings" title="Ustawienia" class="edit">Przejdź do ustawień</a></p>';
			echo '<div class="clear"></div>';
		}
		public static function add_dashboard() {
			if ( !current_user_can('manage_options') ){ 
				return; 
			}
			wp_add_dashboard_widget( WORDCAMP_PLUGIN_LONGNAME,'WordCamp Poznań', array('WordCampPoznan2011','add_dashboard_widget') );
		}
		
		public static function add_adminbar() {
			global $wp_admin_bar;
			if ( !current_user_can('manage_options') || !is_super_admin() || !is_admin_bar_showing()){
				return;
			}
			$wp_admin_bar->add_menu(array( 'id' => 'wordcamp', 'title' => 'WordCamp', 'href' => admin_url('admin.php').'?page=wordcamp'));
			$wp_admin_bar->add_menu(array( 'parent' => 'wordcamp', 'title' => 'Informacje', 'href' => admin_url('admin.php').'?page=wordcamp'));
			$wp_admin_bar->add_menu(array( 'parent' => 'wordcamp', 'title' => 'Ustawienia', 'href' => admin_url('admin.php').'?page=wordcamsettings'));
		}
	}
	
	register_activation_hook( __FILE__, array('WordCampPoznan2011','plugin_activate') );
	register_deactivation_hook(__FILE__, array('WordCampPoznan2011','plugin_deactivate'));
	add_action('admin_menu', array('WordCampPoznan2011','init_admin_menu'));
	add_action('wp_dashboard_setup', array('WordCampPoznan2011','add_dashboard') );
	add_action('admin_bar_menu', array('WordCampPoznan2011','add_adminbar'),100);
}